


         /*********************************************************/
         /*                                                       */
         /*                 COPYRIGHT (C) 1988 BY                 */
         /* CAD Group of Dipartimento di Automatica e Informatica */
         /*             Politecnico di Torino, Italy.             */
         /*                  ALL RIGHTS RESERVED.                 */
         /*                                                       */
         /* This software is furnished under a license and may be */
         /* used and copied  only in accordance with the terms of */
         /* such license. Unauthorized copies will be persecuted. */
         /*                                                       */
         /*********************************************************/





/******************************************************************************

    Filename:         crest.c

    Author:           Pier Luca Montessoro

    Creation date:    16 January 1989

    Contents:         symble table extractor from Mozart netlist


                          *** DOCUMENTATION ***


 ******************************************************************************/

#include <stdio.h>

#include "env.h"


#define NET_EXTENSION      ".dee"
#define SYM_TAB_EXTENSION  ".smt"


main (argc, argv)

int   argc;
char  *argv[];

{

   extern FILE           *fopen();
   extern int            fclose();
   extern int            fseek();
   long                  st_offset;
   char                  file_name[64];
   FILE                  *fp_in, *fp_out;
   char                  ch;


   if (argc != 2)
   {
      printf ("Wrong number of arguments (1st: netlist).\n");
      exit(4);
   }

   /* open the file containing the symbol table */
   sprintf (file_name, "%s%s", argv[1], NET_EXTENSION);
   if ((fp_in = fopen (file_name, "r")) == NULL)
   {
      printf ("Network file not found\n");
      exit(4);
   }

   /* open the output file */
   sprintf (file_name, "%s%s", argv[1], SYM_TAB_EXTENSION);
   if ((fp_out = fopen (file_name, "w")) == NULL)
   {
      printf ("Error opening output file\n");
      exit(4);
   }


   /* read the address of the first record (the first and second lines are 
      skipped) */

   while (getc (fp_in) != '\n');
   while (getc (fp_in) != '\n');

   fscanf (fp_in, "%ld", &st_offset);   


   /* position the file pointer at the beginning of the symbol table */

   if (fseek (fp_in, st_offset, 0))
   {
      printf ("WARNING: Reading symbol table failed\n");
      fclose (fp_in);
      fclose (fp_out);
      exit(4);
   }

   while ((ch = getc (fp_in)) != EOF)
   {
      putc (ch, fp_out);
   }

   fclose (fp_in);
   fclose (fp_out);

   printf ("Symbol table extracted.\n");

}
