

         /*********************************************************/
         /*                                                       */
         /*                 COPYRIGHT (C) 1988 BY                 */
         /* CAD Group of Dipartimento di Automatica e Informatica */
         /*             Politecnico di Torino, Italy.             */
         /*                  ALL RIGHTS RESERVED.                 */
         /*                                                       */
         /* This software is furnished under a license and may be */
         /* used and copied  only in accordance with the terms of */
         /* such license. Unauthorized copies will be persecuted. */
         /*                                                       */
         /*********************************************************/





/****************************************************************************** 

    Filename:         env.h

    Author:           Pier Luca Montessoro

    Creation date:    11 January 1988

    Contents:         environment definition for compatibility


                          *** DOCUMENTATION ***

      Some parameters and costants are defined depending from the host machine
 and operating system.

 IMPORTANT:  All the codes are defined and used as 'unsigned char'. This 
             ensures the correct parameters passing between functions also
             on 16 bits word-width machines.


 ******************************************************************************/



#ifdef  VAX11C

#define ENVIRONMENT "DEC VAX with VMS"
#define LSB_MSB 1
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>
#include <stsdef.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tbuffer

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define MSG_OK  STS$M_MSG_NO & (EXIT_OK << STS$V_MSG_NO)
#define MSG_ERR STS$M_MSG_NO & (EXIT_ER << STS$V_MSG_NO)
#define MSG_SYS STS$M_MSG_NO & (EXIT_SY << STS$V_MSG_NO)
#define MSG_BUG STS$M_MSG_NO & (EXIT_BU << STS$V_MSG_NO)
#define VMS_URC STS$M_INHIB_MSG | STS$M_CUST_DEF | STS$M_FAC_SP
#define NORMAL_EXIT_STATUS        (STS$K_SUCCESS | VMS_URC | MSG_OK)
#define USER_ERROR_EXIT_STATUS    (STS$K_SEVERE  | VMS_URC | MSG_ERR)
#define SYSTEM_ERROR_EXIT_STATUS  (STS$K_SEVERE  | VMS_URC | MSG_SYS)
#define BUG_EXIT_STATUS           (STS$K_SEVERE  | VMS_URC | MSG_BUG)

#endif



/******************************************************************************/


#ifdef  ULTRIX

#define ENVIRONMENT "DEC VAX with ULTRIX"
#define LSB_MSB 1
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#ifdef  tolower
#undef  tolower
#endif
#define tolower no_tolower
extern char  no_tolower();

#ifdef  toupper
#undef  toupper
#endif
#define toupper no_toupper
extern char  no_toupper();

#ifdef  _tolower
#undef  _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))

#ifdef  _toupper
#undef  _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  EUNICE

#define ENVIRONMENT "DEC VAX with EUNICE"
#define LSB_MSB 1
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  IBMRT

#define ENVIRONMENT "IBM PC RT with AIX"
#define LSB_MSB 0
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  IBMAT

#define ENVIRONMENT "IBM PC AT with MS/DOS"
#define LSB_MSB 1
#define WORD_SIZE 16
#define LIMITED_MACRO_LENGTH 1

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 0

#define malloc no_malloc
extern char  *no_malloc();

#define free no_free
extern int   no_free();

#define cfree no_cfree
extern int   no_cfree();

#define times no_times
extern int   no_times();

#define times_buffer_type struct tbuffer

struct tbuffer             /* this structure contains              */
{                          /* the information returned by the O.S. */
   long proc_user_time;    /* It is composed of four words         */
   long proc_system_time;  /* containing system and user,          */
   long child_user_time;   /* process and children times.          */
   long child_system_time; /* For more information see:            */
};                         /* - Programming in VAX-11 C, Digital,  */
                           /*   AA-L370A-TE, page 158, or          */
                           /* - Unix User Manual, TIMES(2)         */

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  IBMVMCMS

#define ENVIRONMENT "IBM VM/CMS"
#define LSB_MSB 0
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  HPUX

#define ENVIRONMENT "HP 9000/320 with HP-UX"
#define LSB_MSB 0
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#ifdef  tolower
#undef  tolower
#endif
#define tolower no_tolower
extern char  no_tolower();

#ifdef  toupper
#undef  toupper
#endif
#define toupper no_toupper
extern char  no_toupper();

#ifdef  _tolower
#undef  _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))

#ifdef  _toupper
#undef  _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  ATT

#define ENVIRONMENT "AT&T 3B2 with UNIX SYSTEM V"
#define LSB_MSB 0
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  SUN

#define ENVIRONMENT "SUN with UNIX"
#define LSB_MSB 0
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#ifdef  tolower
#undef  tolower
#endif
#define tolower no_tolower
extern char  no_tolower();

#ifdef  toupper
#undef  toupper
#endif
#define toupper no_toupper
extern char  no_toupper();

#ifdef  _tolower
#undef  _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))

#ifdef  _toupper
#undef  _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


#ifdef  APOLLO

#define ENVIRONMENT "APOLLO DOMAIN"
#define LSB_MSB 0
#define WORD_SIZE 32
#define LIMITED_MACRO_LENGTH 0

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#define ASYNC_MSG_IMPLEMENTED 1

#define times_buffer_type struct tsm

#ifdef  tolower
#undef  tolower
#endif
#define tolower no_tolower
extern char  no_tolower();

#ifdef  toupper
#undef  toupper
#endif
#define toupper no_toupper
extern char  no_toupper();

#ifdef  _tolower
#undef  _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))

#ifdef  _toupper
#undef  _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))

#define EXIT_OK 0
#define EXIT_ER 1
#define EXIT_SY 2
#define EXIT_BU 3
#define NORMAL_EXIT_STATUS        EXIT_OK
#define USER_ERROR_EXIT_STATUS    EXIT_ER
#define SYSTEM_ERROR_EXIT_STATUS  EXIT_SY
#define BUG_EXIT_STATUS           EXIT_BU

#endif



/******************************************************************************/


/* commonly used constants */

#ifdef  TRUE
#undef  TRUE
#endif
#define TRUE   (unsigned char) 1
#ifdef  FALSE
#undef  FALSE  
#endif
#define FALSE  (unsigned char) 0
#ifdef  VOID
#undef  VOID
#endif
#define VOID   0

#define MAX_UNSIGNED  (unsigned long) 0xFFFFFFFF      /* 4294967295 */

